<template>
  <div
    class="m-20 flex justify-center process-state-message"
    v-if="!changesConcernUserId"
  >
    You're not on your profile settings. Please go back to your page and try again.
  </div>
  <div v-else>
    <div class="m-20 flex justify-center">
      <div
        v-if="
          processState === 'wait for user input' ||
          processState === 'changes are refused'
        " 
      >

        <div class="header">
          <p class="my-10">
            {{ $t('userSettings.editProfile.title') }}
          </p>
        </div>

        <div class="w-full max-w-sm">

          <div
            class="md:flex md:items-center mb-6"
          >
            <div class="md:w-1/3"></div>
            <div class="md:w-2/3 relative">
              <img
                :src="userInputs.avatar"
                :alt="$t('userSettings.editProfile.avatarAltText')"
                class="w-37.5 h-37.5 object-contain"
              >

              <div
                class="absolute bottom-0 right-0 m-1"
              >
                <!-- The actual input to actually get the file. But not displayed.
                It will be triggerred by the next button which layout can be
                customized -->
                <input
                  ref="avatarFileInput"
                  type="file"
                  accept="image/*"
                  @input="setAvatar"
                  style="display:none"
                >
                <!-- The button to trigger the invisible input element above. -->
                <button
                  class="ada-button-overlay"
                  @click="$refs.avatarFileInput.click()"
                >
                  {{ $t('userSettings.action.change') }}
                </button>
              </div>
            </div>
          </div>


          <div class="md:flex md:items-center mb-1">
            <div class="md:w-1/3">
              <label
                class="ada-form-label"
                for="the-page-user-settings--display-name"
              >
                {{ $t('userSettings.editProfile.displayName') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <input
                v-model="userInputs.displayName"
                class="ada-text-input w-full"
                id="the-page-user-settings--display-name"
                type="text"
              >
            </div>
          </div>

          <div
            class="md:flex md:items-center mb-5"
          >
            <div class="md:w-1/3">
            </div>
            <div class="md:w-2/3 warning">
              <div
                v-if="!validDisplayName"
              >
                {{ $t('userSettings.editProfile.displayNameConstraints') }}
              </div>
            </div>
          </div>

          <div class="md:flex md:items-center mb-6">
            <div class="md:w-1/3">
              <label
              class="ada-form-label"
                for="the-page-user-settings--bio"
              >
                {{ $t('userSettings.editProfile.bio') }} 
              </label>
            </div>
            <div class="md:w-2/3">
              <textarea
                v-model="userInputs.bio"
                class="ada-text-input w-full h-48"
                id="the-page-user-settings--bio"
              />
            </div>
          </div>

          <div class="md:flex md:items-center mb-6">
            <div class="md:w-1/3"/>
              <div class="md:w-2/3 text-sm">
                <router-link
                  to="/change-password"
                >
                  <button
                    class="ada-button w-full"
                    type="button"
                  >
                    {{ $t('userSettings.action.changePassword') }}
                  </button>
                </router-link>
              </div>
          </div>

          <div class="md:flex md:items-center mb-1">
            <div class="md:w-1/3">
              <label
                class="ada-form-label"
                for="the-page-user-settings--personal-id"
              >
                {{ $t('userSettings.editProfile.personalId.text') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <input
                v-model="userInputs.personalId"
                class="ada-text-input w-full"
                id="the-page-user-settings--personal-id"
                type="text"
                @keypress="checkKeyBeforeContinue($event)"
              >
            </div>
          </div>

          <div class="md:flex md:items-center mb-6">
            <div class="md:w-1/3">
            </div>
            <div
              class="md:w-2/3 text-sm"
            >
              <div class="mb-2 warning">
                <div
                  v-if="!validPersonalId"
                >
                  {{ $t('userSettings.editProfile.personalId.constraints') }}
                </div>
              </div>
              <div class="info-personnal-id">
                {{ $t('userSettings.editProfile.personalId.info') }}
              </div>
              <div class="info-url-id">
                {{ expectedProfileUrl }}
              </div>
              <div class="info-personnal-id">
                {{ $t('userSettings.editProfile.personalId.allowedCharacters') }}
              </div>
            </div>
          </div>

          <div>
            <label
              class="ada-form-label"
              for="the-page-user-settings--external-link"
            >
              {{ $t('userSettings.editProfile.otherUsernamesText') }}
            </label>
          </div>

          <div
            v-for="platform in userInputs.otherPlatforms"
            class="md:flex md:items-center mb-6"
          >
            <div class="md:w-1/3">
              <label
                class="ada-form-label"
                :for="`the-page-user-settings--${platform.id}-username`"
              >
                {{ platform.name }}
              </label>
            </div>
            <div class="md:w-2/3">
              <input
                v-model="platform.username"
                class="ada-text-input w-full"
                :id="`the-page-user-settings--${platform.id}-username`"
                type="text"
              >
            </div>
          </div>   

          <div class="md:flex md:items-center">
            <div class="md:w-1/3"></div>
            <div class="md:w-2/3 md:flex md:justify-between md:items-center">
              <div class="md:w-2/3">
                <button
                  :class="isSubmissionReady ? 'ada-button' : 'ada-button-off'"
                  type="button"
                  @click="applyChanges"
                >
                  {{ $t('userSettings.action.applyChanges') }}
                </button>
              </div>
              <router-link
                :to="`/people/${userId}`"
                class="ada-button md:w-1/3"
              >
                {{ $t('userSettings.action.cancel') }}
              </router-link>
            </div>
          </div>
        </div>
        <div
          class="my-10 process-state-message"
          v-if="processState === 'changes are refused'"
        >
          <p>
            {{ changeRequestsError }}
          </p>
        </div>
      </div>
      <div
        v-if="processState === 'wait for request response'"
        class="process-state-message"
      >
        {{ $t('userSettings.process.requestSend') }}
      </div>
      <div
        v-if="processState === 'changes applied'"
        class="process-state-message"
      >
        {{ $t('userSettings.process.changesApplied') }}
      </div>
    </div>
  </div>
 
</template>

<script>
import { v4 as uuidv4 } from 'uuid'
import { reactive, watchEffect, computed } from 'vue'
import { useStore, useSubmitUserInfo } from '../store.js'
import router from '../router'
import { adacraftStorageUrl } from '../config'

const charsAreValidForPersonalId = function (characters) {
  // We only accept alphanum characters plus _ . -
  return /^[A-Za-z0-9_.-]+$/.test(characters);
}

export default {
  name: 'ThePageUserSettings',
  props: {
    id: {
      type: String,
      required: true
    }
  },
  setup(props) {
    const { authentification, currentUser } = useStore()
    const faunadbUser = computed(() => (authentification.faunadbUser))
    
    const userId = props.id

    const changesConcernUserId = computed (() => (
      faunadbUser.value !== undefined &&
      props.id === currentUser.value.id
    ))

    const userInputs = reactive({
      avatar: '',
      displayName: '',
      bio: '',
      personalId: '',
      otherPlatforms: [
        {
          id: 'scratch',
          name: 'Scratch',
          username: ''
        },
        {
          id: 'twitter',
          name: 'Twitter',
          username: ''
        },
        {
          id: 'instagram',
          name: 'Instagram',
          username: ''
        },
        {
          id: 'youtube',
          name: 'YouTube',
          username: ''
        },
        {
          id: 'github',
          name: 'GitHub',
          username: ''
        },
        {
          id: 'cocrea',
          name: 'Cocrea',
          username: ''
        },
      ]
    })

    watchEffect(() => {
      if (faunadbUser.value) {
        const name = authentification.user
        userInputs.avatar = faunadbUser.value.data.avatar ||  `https://api.dicebear.com/7.x/identicon/svg?seed=${name}`
        userInputs.displayName = faunadbUser.value.data.user_metadata.full_name
        userInputs.bio = faunadbUser.value.data.bio || ''
        userInputs.personalId = 
          // For legacy reasons (in particular for handling uniqueness in
          // FaunaDB), the personal ID is stored in the "username" field
          faunadbUser.value.data.username || ''
        for (const platform of userInputs.otherPlatforms) {
          platform.username =
            faunadbUser.value.data[`${platform.id}Username`] || ''
        }
      }
    })

    const expectedProfileUrl = computed(() => {
      const faunaId = faunadbUser.value ? faunadbUser.value.ref.value.id : ''
      const id = userInputs.personalId === '' ? faunaId : userInputs.personalId
      return `${window.location.origin}/people/${id}`
    })

    const validDisplayName = computed(() => (
      userInputs.displayName.length >= 3 &&
      userInputs.displayName.length <= 30
    ))
    
    // When user signs up and doesn't want to create a personal ID,
    // we keep undefined value so the personal ID will be Fauna's one.
    // If user decides to create one, he won't be able to go back with an empty personnal ID.
    const validPersonalId = computed(() => (
      (userInputs.personalId.length >= 3 && userInputs.personalId.length <= 30) ||
      (userInputs.personalId === '' && authentification.faunadbUser?.data.username === undefined)))

    const { processState, changeRequestsError, submitUserInfo } = useSubmitUserInfo()

    const changesToApply = computed (() => {
      const changes = {}
      if(faunadbUser.value === undefined) {
        return changes
      }
      if (userInputs.avatar !== faunadbUser.value.data.avatar) {
        changes.avatar = userInputs.avatar
      }
      if (userInputs.displayName !== faunadbUser.value.data.user_metadata.full_name) {
        changes.user_metadata = {}
        changes.user_metadata.full_name = userInputs.displayName
      }
      if (userInputs.bio !== faunadbUser.value.data.bio) {
        changes.bio = userInputs.bio
      }
      if (
        userInputs.personalId !== ''
        && charsAreValidForPersonalId(userInputs.personalId)
        && userInputs.personalId !== faunadbUser.value.data.username
      ) {
        // For legacy reasons (in particular for handling uniqueness in
        // FaunaDB), the personal ID is stored in the "username" field
        changes.username = userInputs.personalId
      }
      for (const platform of userInputs.otherPlatforms) {
        const newUsername = platform.username
        if (newUsername !== faunadbUser.value.data[`${platform.id}Username`]) {
          changes[`${platform.id}Username`] = newUsername
        }
      }
      return (changes)
    })

    let isSubmissionReady = computed(() =>
      (Object.keys(changesToApply.value).length > 0) &&
      (validDisplayName.value && validPersonalId.value)
    )

    const applyChanges = async function () {
      if (isSubmissionReady) {
        await submitUserInfo(changesToApply.value)
        if (processState.value === 'changes applied') {
          router.push(`/people/${currentUser.value.id}`)  
        }
      }
    }

    return {
      authentification,
      userId,
      changesConcernUserId,
      userInputs,
      validDisplayName,
      validPersonalId,
      expectedProfileUrl,
      processState,
      changeRequestsError,
      applyChanges,
      isSubmissionReady
    }
  },
  methods: {
    setAvatar () {
      const file = this.$refs.avatarFileInput.files[0]
      if (!file.type.startsWith('image/')) {
        alert(
          `The avatar must be an image (you have selected the file ` +
          `"${file.name}" which type is "${file.type}").\n` +
          `\n` +
          `Please choose another file.`
        )
      } else {
        const userId = this.authentification.faunadbUser.data.id.substr(0, 8)
        const uniqueId = uuidv4().substr(0, 8)
        const extension = file.name.split('.').pop()
        const imageUrl = `${adacraftStorageUrl}/users/${userId}/data/avatar/${uniqueId}.${extension}`
        fetch(imageUrl, {
            "credentials": "omit",
            "headers": {
                "Accept": "*/*",
                'Content-Type': file.type
            },
            "body": file,
            "method": "PUT",
            "mode": "cors"
        }).then(response => {
          this.userInputs.avatar = imageUrl
        })
        .catch((error) => {
          this.changeRequestsError = error.message
          this.processState = 'changes are refused'
          console.log(`error while submitting the new avatar: ` + error)
        })
      }
    },
    checkKeyBeforeContinue (event) {
      const char = String.fromCharCode(event.keyCode)
      if(charsAreValidForPersonalId(char)) {
        return true
      } else {
        event.preventDefault()
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.header {
  @apply m-10 max-w-sm;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-300;
}

.warning {
  @apply text-center text-base;
  @apply text-red-400;
  @apply dark:text-red-600;
}

.info-personnal-id {
  @apply text-gray-500;
  @apply dark:text-gray-400;
}

.info-url-id {
  @apply my-4;
  @apply text-gray-800;
  @apply dark:text-gray-300;
}

.process-state-message {
  @apply dark:text-gray-300;
}
</style>